<!DOCTYPE html>
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>Ambassadors' Scheme 2014: Handling Data</title>
</head>
<body>
<h1>Handling Data</h1>
<?php
	ini_set("display_errors", 1);
	echo "Entering PHP script<br />";
	
	// Testing
	// -------
	$TESTING = 0;
	function Test($switch,$str) {
		global $TESTING;
		if ($TESTING && $switch) print "<br/>TEST: $str<br/>\n";
	}

	// Access the database and table, ready for writing
	// ------------------------------------------------------
	$info = "/home/mps/private/info.php";
	include $info;

	$link = mysql_connect("stusql.dcs.shef.ac.uk", "mps", $$myPass);
	if ($link) { 
		echo "Connected to server<br />\n"; 
	} else {
		die("Unable to connect to SQL server");
	}

	mysql_select_db("mps") 
	  or die("Unable to select database");
	echo "Connected to database<br />\n";

	// Table name
	// ----------
	$table = "ambassadors2014";

	$query = 'CREATE TABLE IF NOT EXISTS ' . $table . ' ('
		   . 'id INT AUTO_INCREMENT NOT NULL PRIMARY KEY, '
		   . 'teamname TEXT, '
		   . 'secretkey TEXT, '
		   . 'plaintext TEXT, '
		   . 'ciphertext TEXT, '
		   . 'ipaddress TEXT, '
		   . 'tstamp TIMESTAMP'
		   . ');';
		   
	Test($query,$query);

	mysql_query($query)
		or die ('Sorry! I cannot find the table: ' . mysql_error());

	$teamname   = isset($_REQUEST['teamname'])
	            ? mysql_real_escape_string($_REQUEST['teamname'])
				: "";
	if (!$teamname) { die("ABORTED: No team name specified"); }
	
	$plaintext  = isset($_REQUEST['plaintext'])
	            ? mysql_real_escape_string($_REQUEST['plaintext'])
				: "";
	if (!$plaintext) { die("ABORTED: No plaintext specified"); }
	
	$secretkey  = isset($_REQUEST['secretkey'])
	            ? mysql_real_escape_string($_REQUEST['secretkey'])
				: "";
	if (!$secretkey) { die("ABORTED: No secret key specified"); }
	
	$ciphertext = isset($_REQUEST['ciphertext'])
	            ? mysql_real_escape_string($_REQUEST['ciphertext'])
				: "";
	if (!$ciphertext) { die("ABORTED: No ciphertext specified"); }
	
	$ipaddress  = mysql_real_escape_string($_SERVER['REMOTE_ADDR']);
	if (!$ipaddress) { die("ABORTED: No IP address"); }
	
	
	$query = "INSERT INTO $table "
	       . '(teamname,secretkey,plaintext,ciphertext,ipaddress,tstamp) '
		   . "VALUES('$teamname', '$secretkey', '$plaintext', '$ciphertext', '$ipaddress', NOW());";
	Test($query,"Query<br />\n$query");
	mysql_query($query)
		or die ('Sorry! I cannot insert your challenge into the table: ' . mysql_error());
		
	echo "Challenge added to database<br />\n";

	// FIND A CHALLENGE (OR OFFER MINE AS AN ALTERNATIVE)
	
	$myChallenge = "ALPCS'Z RZ YSLH EZ ZPKSE O UMRSH SMRSH VR L WWNLE YWNLE WWRI EZBPKSE TVV L YWNLE WWNLE'D PBX L DZPKSE ZPKSE CU E WTUOX YTUOX WTYL XZYWNLE";
	
	$challenge = "";
	$query = "SELECT * FROM $table WHERE teamname != '" . $teamname . "';";
	$result = mysql_query($query) 
		or die("Unable to load challenges: " . mysql_error());
		
	$nrows = mysql_num_rows($result);
	$nrows = ($nrows < 1) ? 0 : $nrows;
	if ($nrows) {
		$r = 0;
		$cnum = rand(1,$nrows);
		while ($r < $cnum) { $row = mysql_fetch_assoc($result); $r++; }
	}
	mysql_free_result($result);

	mysql_close();
	echo "All connections closed<br/>\n";
?>

<?php  if ($nrows) { ?>
	<h1>Decrypt one of these cipher texts</h1>
<?php } else { ?>
	<h1>Decrypt this cipher text</h1>
	Congratulations! You are the first team to submit a challenge, so I'm 
	setting you one of my own.
<?php } ?>

	<p>
	REMEMBER. The first job is to find the length of the key by identifying
	repeated patterns of letters, and counting how far apart they are. The
	key's length is likely to be a factor of this gap length. Then look online
	for frequency analysis tools that might help you identify how each letter 
	of the key affected the letter E. If you can't find any useful tools, try 
	designing one - you can code it later!
	</p>
	
	<table cellpadding=3 border=1>
	<tr><th>ID</th><th>Challenger</th><th>Cipher</th></tr>
<?php if ($nrows) { ?>
	<tr>
		<td><?php echo stripslashes($row['id']); ?></td>
		<td><?php echo stripslashes($row['teamname']); ?></td>
		<td><?php echo stripslashes($row['ciphertext']); ?></td>
	</tr>
<?php } ?>
	<tr>
		<td>0</td>
		<td>Mike Stannett DCS</td>
		<td><?php echo $myChallenge; ?></td>
	<tr>
	</table>

</body></html>